/* $RCSFile: ADNDynDownloadSession.cs $
 * Apache license v2 2011 by Christian Surieux
 * $Source: ?/AddonNice.Emailing.Settings/CRM/ADNDynDownloadSession.cs $
 * $log$
 * Revision 53 2010/10/02 15:02:22  christian.surieux
 *   Updated ADNDynPrivateDocument and DownloadSession for PrimaryFieldStringValue and changed Telerik
 * Revision 23 2010/10/01 11:24:58  christian.surieux
 *   Fixing temporary version on 1/10/2010
 * Revision 10 2010/08/09 10:13:18  christian.surieux
 *   Added Log comment to all cs files
 */

using System;
using System.Diagnostics;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;
using System.Xml;
using System.Data.SqlClient;
using System.Globalization;

using AddonNice.Helpers;
using AddonNice.CRMWrapper;
using AddonNice.CRMEMailing;
using AddonNice.Diagnostics;
using AddonNice.Configuration;
using AddonNice.Core;
using System.Data;

namespace AddonNice.CRMWrapper.CRMEMailing
{
	#region ADNDynDownloadSession TraceSwitch for CRM
	public class DynDownloadSessionTrace
	{
		static public ADNTraceSwitchW	Sw	=	new ADNTraceSwitchW("DynDownloadSessionTrace","Trace Switch for CRM ADNDynDownloadSessionTracen");
	}
	#endregion ADNDynDownloadSession TraceSwitch for CRM

    public class InstallDownloadSession : InstallDynEntity
    {
        public override DynEntity NewEntity(string schemaName,CRMWrapperBase wrapper)
        {
            if ( InstallTraceSwitch.Sw.TraceVerbose )
                Trace.WriteLine("[V]InstallDownloadSession NewEntity CALLED.",InstallTraceSwitch.Sw.Info);
            return new ADNDynDownloadSession(wrapper,string.Empty);
        }

        public override bool InstallInCrmServer(int PortalID,bool isMainPortal,IDictionary stateSaver,CRMWrapperBase wrapper,DynEntity dynEnt,bool publishCustom,bool publishSiteMap,bool publishIsv)
        {
            if ( InstallTraceSwitch.Sw.TraceVerbose )
                Trace.WriteLine("[V]InstallDownloadSession InstallInCrmServer BEG",InstallTraceSwitch.Sw.Info);
            bool ret    =   base.InstallInCrmServer(PortalID,isMainPortal,stateSaver,wrapper,dynEnt,publishCustom,publishSiteMap,publishIsv);
            if ( InstallTraceSwitch.Sw.TraceVerbose )
                Trace.WriteLine(string.Format(CultureInfo.InvariantCulture,"[V]InstallDownloadSession InstallInCrmServer END ret: {0}.",ret),InstallTraceSwitch.Sw.Info);
            return ret;
        }
    }

    public class ADNDynDownloadSession : DynEntity
    {
        protected class Ftor: DFactor
        {
            public Ftor() : base(AStr.adndownloadsession)
            {}

            public override Type DynType
            { get { return typeof(ADNDynDownloadSession); } }

            public override string DynTypename
            {   get{ return AStr.adndownloadsession;}}

            public override DynEntity Build()
            {
                return new ADNDynDownloadSession();
            }
            public override DynEntity Build(CRMWrapperBase w, InternalDynamicEntity dEntity, PropertyDescriptorCollection wproperties)
            {   return new ADNDynDownloadSession(w, dEntity, wproperties, null);}

            public override DynEntity Build(CRMWrapperBase w, string PrimaryFieldValue)
            {   return new ADNDynDownloadSession(w, PrimaryFieldValue);}

            public override DynEntity Build(CRMWrapperBase w,Guid PrimaryKeyValue)
            {   return new ADNDynDownloadSession(w,PrimaryKeyValue);}
        }

        // Static Ctor to force FTor insert in DynTypes
        static ADNDynDownloadSession(){new Ftor();}

        public override bool HasOwningBusinessUnitProperty
        {
            get{   return true;}
        }

        /// <summary>
        /// Reserved for template methods, DO NOT USE directly
        /// </summary>
        public ADNDynDownloadSession() : base()
        {}

        public ADNDynDownloadSession(CRMWrapperBase w, string name)
            : base(w, AStr.adndownloadsession)
        {
            AddStringProperty(AStr.adntitle,name);
        }

        public ADNDynDownloadSession(CRMWrapperBase w, Guid CrmId)
            : base(w, AStr.adndownloadsession,CrmId)
        {}

        public ADNDynDownloadSession(CRMWrapperBase w,InternalDynamicEntity dEntity,PropertyDescriptorCollection wcolumnDescriptors,InternalColumnSet s)
            : base(w,dEntity,wcolumnDescriptors,s)
        {}

        public ADNDynDownloadSession(ResetWrapperHandler fn, string name)
            : base(fn, AStr.adndownloadsession)
        {
            AddStringProperty(AStr.adntitle,name);
        }

        public ADNDynDownloadSession(ResetWrapperHandler fn, Guid CrmId)
            : base(fn, AStr.adndownloadsession,CrmId)
        {}

        public ADNDynDownloadSession(ResetWrapperHandler fn,InternalDynamicEntity dEntity,PropertyDescriptorCollection wcolumnDescriptors,InternalColumnSet s)
            : base(fn,dEntity,wcolumnDescriptors,s)
        {}

        #region accessors to ADNDynDownloadSession fields

        /// <summary>
        /// CRM Id for the DownloadSession
        /// </summary>
        [CrmDynAttribute(AStr.adndownloadsession)]
        public Guid adndownloadsessionid
        {
            get
            {
				return KeyPropertyValue(AStr.adndownloadsessionid);
            }
            set
            {
                 AddKeyProperty(AStr.adndownloadsessionid,value);
            }
        }

        protected override void SetCrmIdProperty(Guid crmId)
        {
            adndownloadsessionid   =   crmId;
        }

        public override Guid PrimaryKeyGuidValue
        {
            get
            {
                return adndownloadsessionid;
            }
            set
            {
                adndownloadsessionid = value;
            }
        }

        public override string PrimaryFieldName
        {
            get
            {
               return AStr.adntitle;
            }
           set
           {}
        }

        public override string PrimaryFieldStringValue
        {
            get
            {
                return adntitle;
            }
            set
            {
                adntitle =   value;
            }
        }

        public override string SchemaName
        {
           get
           {
               return AStr.adndownloadsession;
           }
           set
           {
               _SchemaName  =   AStr.adndownloadsession;
           }
        }

        /// <summary>
        /// Title
        /// </summary>
        [CrmDynAttribute(AStr.adndownloadsession)]
        public string adntitle
        {
            get
            {
                if ( this[AStr.adntitle] != null )
                    return StringPropertyValue(AStr.adntitle);
                const string strErr   =   "[E]DynPrivateDocument adntitle not found";
                if ( CRMTraceSwitch.Sw.TraceError )
                    Trace.WriteLine( strErr,CRMTraceSwitch.Sw.Info);
                throw new Exception(strErr);
            }
            set
            {
                 AddStringProperty(AStr.adntitle,value);
            }
        }

        /// <summary>
        /// this is the prefix used to download these files
        /// </summary>
        [CrmDynAttribute(AStr.adndownloadsession)]
        public string adnprefix
        {
            get
            {
                if ( this[AStr.adnprefix] != null )
                    return StringPropertyValue(AStr.adnprefix);
                return string.Empty;
            }
            set
            {
                 AddStringProperty(AStr.adnprefix,value);
            }
        }

        /// <summary>
        /// this is the url from where the physical file will be/has been downloaded in db
        /// </summary>
        [CrmDynAttribute(AStr.adndownloadsession)]
        public bool adnglobal
        {
            get
            {
                if ( !ContainsKey(AStr.adnglobal) )
                    return BooleanPropertyValue(AStr.adnglobal);
                return false;
            }
            set
            {
                 AddBooleanProperty(AStr.adnglobal,value);
            }
        }

        /// <summary>
        /// virtual because on 'detail' records it is only a uniqueidentifier property
        /// </summary>
        [CrmDynAttribute(AStr.adndownloadsession)]
        public Guid owningbusinessunit
        {
            get
            {
                return LookupPropertyValue(CrmStr.owningbusinessunit);
            }
            set
            {
                AddLookupProperty(CrmStr.owningbusinessunit,CrmStr.businessunit,value);
            }
        }

        public string owningbusinessunitName
        {
            get
            {
                return LookupPropertyName(CrmStr.owningbusinessunit);
            }
        }

        [CrmDynAttribute(AStr.adndownloadsession)]
        public Guid campaignid
        {
            get
            {
                if ( ContainsKey(AStr.adncampaignid) )
                    return LookupPropertyValue(AStr.adncampaignid);
                return Guid.Empty;
            }
            set
            {
                AddLookupProperty(AStr.adncampaignid,CrmStr.campaign,value);
            }
        }

        public string campaignName
        {
            get
            {
                return LookupPropertyName(AStr.adncampaignid);
            }
        }

        [CrmDynAttribute(AStr.adndownloadsession)]
        public Guid listid
        {
            get
            {
                if ( ContainsKey(AStr.adnlistid) )
                    return LookupPropertyValue(AStr.adnlistid);
                return Guid.Empty;
            }
            set
            {
                AddLookupProperty(AStr.adnlistid,CrmStr.list,value);
            }
        }

        public string listName
        {
            get
            {
                if ( ContainsKey(AStr.adnlistid) )
                    return LookupPropertyName(AStr.adnlistid);
                return string.Empty;
            }
        }

        #endregion accessors to ADNDynDownloadSession fields

        #region Utilities

        /// <summary>
        /// Build a DataTable which contains all the maketing list from the campaign (if exists) AND the marketing list (if exists) attached to the session
        /// entName: string.empty for all entities, else the entity
        /// </summary>
        public DataTable ReadAllListsTb(ResetWrapperHandler fn,string entName)
        {
            bool hasCampaign                                =    ( campaignid != Guid.Empty );
            if (DynDownloadSessionTrace.Sw.TraceVerbose || CRMDynTraceSwitch.Sw.TraceVerbose)
                Trace.WriteLine( string.Format(CultureInfo.InvariantCulture,"[V]ADNDynDownloadSessionTrace ReadAllListTb BEG entName: {0}, hasCampaign: {1}",entName,hasCampaign),(DynDownloadSessionTrace.Sw.TraceVerbose)? DynDownloadSessionTrace.Sw.Info:CRMDynTraceSwitch.Sw.Info);
            DataTable Tb                                    =   null;
            try
            {
                if ( hasCampaign )
                {
                    ADNDynCampaign dynCamp                  =   DynEntity.GetFromCache<ADNDynCampaign>(CrmStr.campaign,wrapper,fn,campaignid);
                    Tb                                      =   dynCamp.ReadAllListTb(fn,entName);
                }
                if ( listid != Guid.Empty )
                {
                    ADNDynList dynList                      =   DynEntity.GetFromCache<ADNDynList>(CrmStr.list,wrapper,fn,listid,true);
                    bool ok                                 =   dynList.Retrieved;
                    if ( !string.IsNullOrEmpty(entName) )
                        switch( entName )
                        {
                            case CrmStr.account:
                            if ( dynList.createdfromcode != 1 )
                                ok                          =   false;
                            break;
                            case CrmStr.contact:
                            if ( dynList.createdfromcode != 2 )
                                ok                          =   false;
                            break;
                            case CrmStr.lead:
                            if ( dynList.createdfromcode != 4 )
                                ok                          =   false;
                            break;
                        }
                    if ( ok )
                    {
                        SortedList<Guid,ADNDynList> sList   =   new SortedList<Guid,ADNDynList>();
                        sList.Add(listid,dynList);
                        DataTable Tb1                       =   new GenericCrmTable<ADNDynList>(wrapper,fn,CrmStr.list,sList,null);
                        // if there is no list in the campaign, we take this sole list
                        if ( ( Tb == null ) || ( Tb.Rows.Count == 0 ) )
                            Tb                  =   Tb1;
                        else // We add this list to the others
                        {
                            foreach ( DataRow rw in Tb1.Rows )
                            {
                                DataRow nrw     =   Tb.NewRow();
                                for( int i=0 ; i < Tb.Columns.Count; i++ )
                                    nrw[i]      =   rw[i];
                                Tb.Rows.Add(nrw);
                            }
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                if ( CRMDynTraceSwitch.Sw.TraceError )
                    Trace.WriteLine( string.Format(CultureInfo.InvariantCulture,"[E]ADNDynDownloadSessionTrace ReadAllListTb ex: {0}", ex),CRMDynTraceSwitch.Sw.Info);
                throw;
            }
            if (DynDownloadSessionTrace.Sw.TraceVerbose || CRMDynTraceSwitch.Sw.TraceVerbose)
                Trace.WriteLine( string.Format(CultureInfo.InvariantCulture,"[V]ADNDynDownloadSessionTrace ReadAllListTb END Count: {0}",(Tb != null) ? Tb.Rows.Count:0),(DynDownloadSessionTrace.Sw.TraceVerbose)? DynDownloadSessionTrace.Sw.Info:CRMDynTraceSwitch.Sw.Info);
            return Tb;
        }
        
         /// <summary>
        /// Build a DataTable which contains  all the Pivate Documents attached to this Session
        /// SelListId: Guid.Empty for all maketing Lists, else the transmitted marketing List
        /// </summary>
        public DataTable ReadAllPrivateDocsTb(ResetWrapperHandler fn,Guid SelListId)
        {
            bool hasCampaign                                =    ( campaignid != Guid.Empty );
            if (DynDownloadSessionTrace.Sw.TraceVerbose || CRMDynTraceSwitch.Sw.TraceVerbose)
                Trace.WriteLine( string.Format(CultureInfo.InvariantCulture,"[V]ADNDynDownloadSessionTrace ReadAllPrivateDocsTb BEG SelListId: {0}, hasCampaign: {1}",SelListId,hasCampaign),(DynDownloadSessionTrace.Sw.TraceVerbose)? DynDownloadSessionTrace.Sw.Info:CRMDynTraceSwitch.Sw.Info);
            DataTable Tb                                    =   null;
            try
            {
                SortedList<Guid,ADNDynPrivateDocument> RLst         =   ReadAllPrivateDocs(fn,SelListId);
                Tb                                                  =   new GenericCrmTable<ADNDynPrivateDocument>(wrapper,fn,AStr.adnprivatedocument,RLst,null);
            }
            catch (Exception ex)
            {
                if ( CRMDynTraceSwitch.Sw.TraceError )
                    Trace.WriteLine( string.Format(CultureInfo.InvariantCulture,"[E]ADNDynDownloadSessionTrace ReadAllPrivateDocsTb ex: {0}", ex),CRMDynTraceSwitch.Sw.Info);
                throw;
            }
            if (DynDownloadSessionTrace.Sw.TraceVerbose || CRMDynTraceSwitch.Sw.TraceVerbose)
                Trace.WriteLine( string.Format(CultureInfo.InvariantCulture,"[V]ADNDynDownloadSessionTrace ReadAllPrivateDocsTb END Count: {0}",(Tb != null) ? Tb.Rows.Count:0),(DynDownloadSessionTrace.Sw.TraceVerbose)? DynDownloadSessionTrace.Sw.Info:CRMDynTraceSwitch.Sw.Info);
            return Tb;
        }
 
         /// <summary>
        /// Build a DataTable which contains  all the Pivate Documents attached to this Session
        /// SelListId: Guid.Empty for all maketing Lists, else the transmitted marketing List
        /// </summary>
        public SortedList<Guid,ADNDynPrivateDocument> ReadAllPrivateDocs(ResetWrapperHandler fn,Guid SelListId)
        {
            bool hasCampaign                                        =    ( campaignid != Guid.Empty );
            if (DynDownloadSessionTrace.Sw.TraceVerbose || CRMDynTraceSwitch.Sw.TraceVerbose)
                Trace.WriteLine( string.Format(CultureInfo.InvariantCulture,"[V]ADNDynDownloadSessionTrace ReadAllPrivateDocs BEG SelListId: {0}, hasCampaign: {1}",SelListId,hasCampaign),(DynDownloadSessionTrace.Sw.TraceVerbose)? DynDownloadSessionTrace.Sw.Info:CRMDynTraceSwitch.Sw.Info);
            SortedList<Guid,ADNDynPrivateDocument> ResultList       =   null;
            try
            {
                InternalQueryExpression qe                          =   new InternalQueryExpression();
                qe.EntityName                                       =   AStr.adnprivatedocument;
                InternalFilterExpression fi                         =   new InternalFilterExpression();
                List<InternalConditionExpression> cLst              =   new List<InternalConditionExpression>();
                InternalConditionExpression ex1                     =   new InternalConditionExpression();
                ex1.AttributeName                                   =   AStr.adndownloadsessionid;
                ex1.Operator                                        =   InternalConditionOperator.Equal;
                ex1.Values                                          =   new object[]{adndownloadsessionid};
                cLst.Add(ex1);
                if ( SelListId != Guid.Empty )
                {
                    ADNDynList dynList                      =   DynEntity.GetFromCache<ADNDynList>(CrmStr.list,wrapper,fn,SelListId,true);
                    bool ok                                 =   dynList.Retrieved;
                    if ( ok )
                    {
                        InternalConditionExpression ex              =   new InternalConditionExpression();
                        ex.Operator                                 =   InternalConditionOperator.Equal;
                        ex.Values                                   =   new object[]{SelListId};
                        switch( dynList.createdfromcode )
                        {
                            case 1:
                            ex.AttributeName                        =   AStr.adnaccountid;
                            break;
                            case 2:
                            ex.AttributeName                        =   AStr.adncontactid;
                            break;
                            case 4:
                            ex.AttributeName                        =   AStr.adnleadid;
                            break;
                            default:
                            ok                                      =   false;
                            break;
                        }
                        if ( ok )
                            cLst.Add(ex);
                    }
                }
                fi.Conditions                                           =   cLst.ToArray();
                qe.ColumnSet                                            =   new InternalAllColumns();
                qe.Criteria                                             =   fi;
                GenericDynQueryMultiple<ADNDynPrivateDocument> allEntQuery  =   new GenericDynQueryMultiple<ADNDynPrivateDocument>(wrapper,fn,AStr.adnprivatedocument);
                ResultList                                              =    allEntQuery.retrieveSortedList();
            }
            catch (Exception ex)
            {
                if ( CRMDynTraceSwitch.Sw.TraceError )
                    Trace.WriteLine( string.Format(CultureInfo.InvariantCulture,"[E]ADNDynDownloadSessionTrace ReadAllPrivateDocs ex: {0}", ex),CRMDynTraceSwitch.Sw.Info);
                throw;
            }
            if (DynDownloadSessionTrace.Sw.TraceVerbose || CRMDynTraceSwitch.Sw.TraceVerbose)
                Trace.WriteLine( string.Format(CultureInfo.InvariantCulture,"[V]ADNDynDownloadSessionTrace ReadAllPrivateDocs END Count: {0}",(ResultList != null) ? ResultList.Count:0),(DynDownloadSessionTrace.Sw.TraceVerbose)? DynDownloadSessionTrace.Sw.Info:CRMDynTraceSwitch.Sw.Info);
            return ResultList;
        }
 
        #endregion Utilities

        #region Builder
        /// <summary>
        /// Used by install proc when some entity need to be installed in CRM
        /// </summary>
        public override bool HasBuilder
        {
            get{ return true;}
        }

        public override List<MetaDataBuilder> Builder
        {
            get
            {
                EntityBuilder eb                =   new EntityBuilder(AStr.adndownloadsession);
                eb.Description                  =   "AddonNice Xrm EMailing Download session entity.";
                eb.DisplayName                  =   LocalizeHelper.Localize(AStr.ResourceFile,AStr.ResourceItem,"DOWNLOADSESSION_DISPLAYNAME","Download session");
                eb.DisplayCollectionName        =   LocalizeHelper.Localize(AStr.ResourceFile,AStr.ResourceItem,"DOWNLOADSESSION_DISPLAYCOLNAME","Download sessions");
                eb.PrimaryFieldName             =   AStr.adntitle;
                eb.PrimaryFieldDisplayName      =   LocalizeHelper.Localize(AStr.ResourceFile,AStr.ResourceItem,"DOWNLOADSESSION_PRIMARYDISPLAYNAME","Title");
                eb.MaxLength                    =   256;
                List<AttributeBuilder> attList  =   new List<AttributeBuilder>();

                BoolAttributeBuilder ib         =   new BoolAttributeBuilder(AStr.adndownloadsession,AStr.adnglobal);
                ib.DisplayName                  =   LocalizeHelper.Localize(AStr.ResourceFile,AStr.ResourceItem,"DOWNLOADSESSION_GLOBALDOCUMENT","Global document");
                ib.DisplayCollectionName        =   LocalizeHelper.Localize(AStr.ResourceFile,AStr.ResourceItem,"DOWNLOADSESSION_GLOBALDOCUMENTS","Global documents");
                attList.Add(ib);

                StringAttributeBuilder sb       =   new StringAttributeBuilder (AStr.adndownloadsession,AStr.adnprefix);
                sb.DisplayName                  =   LocalizeHelper.Localize(AStr.ResourceFile,AStr.ResourceItem,"DOWNLOADSESSION_PREFIX","Prefix");
                sb.DisplayCollectionName        =   LocalizeHelper.Localize(AStr.ResourceFile,AStr.ResourceItem,"DOWNLOADSESSION_PREFIXS","Prefixes");
                sb.MaxLength                    =   256;
                attList.Add(sb);
                
                List<One2ManyRelationBuilder> relList  =   new List<One2ManyRelationBuilder>();
                
               
                // Campaign relation
                string relSchemaName            =   string.Format("{0}_{1}",CrmStr.campaign,AStr.adndownloadsession);
                string lookupDisplayName        =   LocalizeHelper.Localize(AStr.ResourceFile,AStr.ResourceItem,"DOWNLOADSESSION_CAMPAIGN", "Campaign");
                One2ManyRelationBuilder CampRel =   new One2ManyRelationBuilder(relSchemaName,CrmStr.campaign,AStr.adndownloadsession,-1,
                    CrmStr.campaignid,lookupDisplayName,string.Empty,eb.DisplayName);
                CampRel.MenuGroup               =    InternalAssociatedMenuGroup.Marketing;
                // There is only one Parental relation, so this one will be referential
                CampRel.CascadeReparent         =   CascadeInternalType.NoCascade;
                CampRel.CascadeAssign           =   CascadeInternalType.NoCascade;
                CampRel.CascadeDelete           =   CascadeInternalType.RemoveLink;
                CampRel.CascadeShare            =   CascadeInternalType.NoCascade;
                CampRel.CascadeUnshare          =   CascadeInternalType.NoCascade;
                relList.Add(CampRel);

                // Campaign relation
                relSchemaName                   =   string.Format("{0}_{1}",CrmStr.list,AStr.adndownloadsession);
                lookupDisplayName               =   LocalizeHelper.Localize(AStr.ResourceFile,AStr.ResourceItem,"DOWNLOADSESSION_LIST", "List");
                One2ManyRelationBuilder ListRel =   new One2ManyRelationBuilder(relSchemaName,CrmStr.list,AStr.adndownloadsession,-1,
                    CrmStr.listid,lookupDisplayName,string.Empty,eb.DisplayName);
                ListRel.MenuGroup               =    InternalAssociatedMenuGroup.Marketing;
                // There is only one Parental relation, so this one will be referential
                ListRel.CascadeReparent         =   CascadeInternalType.NoCascade;
                ListRel.CascadeAssign           =   CascadeInternalType.NoCascade;
                ListRel.CascadeDelete           =   CascadeInternalType.RemoveLink;
                ListRel.CascadeShare            =   CascadeInternalType.NoCascade;
                ListRel.CascadeUnshare          =   CascadeInternalType.NoCascade;
                relList.Add(ListRel);

                MetaDataBuilder metab           =   new MetaDataBuilder(eb, attList,relList);
                List<MetaDataBuilder> Lst       =   new List<MetaDataBuilder>();
                Lst.Add(metab);
                return Lst;
                }
        }
        #endregion Builder

        #region IFrame
        public override bool HasIFrameBuilder
        {
            get{ return false;}
        }
        #endregion IFrame

        #region Form Customizer
        
        public override bool HasFormCustomizer
        {
            get{ return true;}
        }

        /// <summary>
        /// Customize Form for the entity adn_DownloadSession 
        /// </summary>
        public override bool CustomizeForm(IDictionary stateSaver,bool publishCustom,bool publishSiteMap,bool publishIsv)
        {
            if (InstallTraceSwitch.Sw.TraceVerbose)
                Trace.WriteLine( "[V]ADNDynDownloadSession CustomizeForm BEG.",InstallTraceSwitch.Sw.Info);
            CrmUtil4Form util           =   new CrmUtil4Form((CrmWrapper4)wrapper, AStr.adndownloadsession);
            ImportExportXml imXml       =   util.Init();
            bool ret                    =   true;
            // category in first tab
            string displayName          =   LocalizeHelper.Localize(AStr.ResourceFile,AStr.ResourceItem,"DOWNLOADSESSION_GLOBAL","Global");
            if ( !util.ExistAttributeInFirstTabAndSection(AStr.adnglobal) )
            {
                util.AddAttributeInFirstTabAndSection(AStr.adnglobal,displayName,AttributeInternalType.Boolean,1,1);
                
                displayName             =   LocalizeHelper.Localize(AStr.ResourceFile,AStr.ResourceItem,"DOWNLOADSESSION_GLOBALDOCUMENT","Global Document");
                util.AddAttributeInSameRow(AStr.adnprivatedocumentid,displayName,AttributeInternalType.Lookup,1,1);
                
                displayName             =   LocalizeHelper.Localize(AStr.ResourceFile,AStr.ResourceItem,"DOWNLOADSESSION_PREFIX","Prefix");
                util.AddAttributeInLastRows(AStr.adnprefix,displayName,AttributeInternalType.String,1,1);
                
                displayName             =   LocalizeHelper.Localize("DOWNLOADSESSION_CAMPAIGN", "Campaign");
                util.AddAttributeInLastRows(AStr.adncampaignid,displayName,AttributeInternalType.Lookup,1,1);
                
                displayName             =   LocalizeHelper.Localize("DOWNLOADSESSION_LIST", "List");
                util.AddAttributeInSameRow(AStr.adnlistid,displayName,AttributeInternalType.Lookup,1,1);

                ret                     =   util.Save(imXml,publishCustom);
            }
            if (InstallTraceSwitch.Sw.TraceVerbose)
                Trace.WriteLine( string.Format(CultureInfo.InvariantCulture,"[V]ADNDynDownloadSession CustomizeForm END Result: {0}",ret), InstallTraceSwitch.Sw.Info);
            return ret;
        }

        #endregion Form Customizer
       
        #region Complete Addon Nice Menu in Crm
        
        public override bool HasAddonNiceMenuExtension
        {
            get{ return true;}
        }

        public override bool CompleteSiteMap(int PortalID,IDictionary stateSaver,bool publishCustom,bool publishSiteMap,bool publishIsv)
        {
            if ( InstallTraceSwitch.Sw.TraceVerbose )
                Trace.WriteLine("[V]ADNDynDownloadSession CompleteSiteMap BEG",InstallTraceSwitch.Sw.Info);
            bool ret                        =   true;
            try
            {
                if ( wrapper.CrmVersion != CrmStr.CrmVersion3 ) 
                {
                    CrmUtil4SiteMap util2   =   new CrmUtil4SiteMap((CrmWrapper4)wrapper);
                    ImportExportXml ieXml   =   util2.Init();
                    // Add the adndownloadsession entity under AddonNice Area in Crm sitemap
                    List<string> lst        =   new List<string>();
                    lst.Add(AStr.adndownloadsession);
                    lst.Add(AStr.adnprivatedocument);
                    string nSubArea         =   CrmUtil4SiteMap.NewEntitySubAreaWithReadPrivileges("adn_downloadsessions",AStr.adndownloadsession,false,lst,"Web");
                    util2.AddNewSubAreaNoImport(StStr.Area_AddonNice, StStr.Group_AddonNice, string.Empty, nSubArea,"adn_downloadsessions");
                    // Add the adnprivatedocument entity under AddonNice Area in Crm sitemap
                    nSubArea                =   CrmUtil4SiteMap.NewEntitySubAreaWithReadPrivileges("adn_privatedocuments",AStr.adnprivatedocument,false,lst,"Web");
                    util2.AddNewSubAreaNoImport(StStr.Area_AddonNice, StStr.Group_AddonNice, string.Empty, nSubArea,"adn_privatedocuments");

                    // Add the adndownloadsession entity under Marketting Area in Crm sitemap
                    nSubArea                =   CrmUtil4SiteMap.NewEntitySubAreaWithReadPrivileges("adn_downloadsessions",AStr.adndownloadsession,false,lst,"Web");
                    util2.AddNewSubAreaNoImport(StStr.Area_Marketing,StStr.Group_Marketing, string.Empty, nSubArea,"adn_downloadsessions");
                    // Add the adnprivatedocument entity under Marketting Area in Crm sitemap
                    nSubArea                =   CrmUtil4SiteMap.NewEntitySubAreaWithReadPrivileges("adn_privatedocuments",AStr.adnprivatedocument,false,lst,"Web");
                    util2.AddNewSubAreaNoImport(StStr.Area_Marketing,StStr.Group_Marketing, string.Empty, nSubArea,"adn_privatedocuments");
                    
                    util2.Save(ieXml,true);
                }
            }
            catch (Exception ex)
            {
                if (InstallTraceSwitch.Sw.TraceError)
                    Trace.WriteLine( string.Format(CultureInfo.InvariantCulture,"[E]ADNDynDownloadSession CompleteSiteMap ex: {0}", ex), InstallTraceSwitch.Sw.Info);
                ret                         =   false;
            }
            if ( InstallTraceSwitch.Sw.TraceVerbose )
                Trace.WriteLine(string.Format(CultureInfo.InvariantCulture,"[V]ADNDynDownloadSession CompleteSiteMap END ret: {0}.",ret),InstallTraceSwitch.Sw.Info);
            return ret;
        }

        #endregion Complete Addon Nice Menu in Crm
    }
}
