﻿/* $RCSFile: CrmMailingUtil.cs $
 * Apache license v2 2011 by Christian Surieux
 * $Source: ?/AddonNice.Emailing.Settings/CrmMailingUtil.cs $
 * $log$
 * Revision 10 2010/08/09 10:13:18  christian.surieux
 *   Added Log comment to all cs files
 */

using System;

namespace AddonNice.CRMEMailing
{
    public enum filenameFmt { fmtGuid, FmtName }
    public enum loadType { FromFolder, FromXmlDoc,FromCsv }

    public class AStr
    {
        public const string ResourceFile            =  "ResourcesEMAIL";
        public const string ResourceItem            =  "CrmMailTemplate";

        public const string EmailingModuleCat       =   "EMailing";
        public const string EMAIL_MOD_CAT           =   "EMAIL_MOD_CAT";

        #region const Guids for Emailing modules
        
        public const string CrmMailTargetPageGuid       =   "{626B830A-7460-42f3-B48A-0C36DEB30ECB}";
        public const string CrmBulkSendMailGuid         =   "{4DADEB1E-908B-4528-8886-69F663E2D311}";
        public const string CrmBSM2Guid                 =   "{EF813C8F-CA63-4B2D-8F17-7ACDC5D0327E}";
        public const string CrmMailTemplateEditorGuid   =   "{A8FF3791-D303-4e34-86A7-7B4441E55A7C}";
        public const string PrivateDocFeederGuid        =   "{B915DE8B-1AD8-464e-8C93-2C7254250B50}";
        public const string PrivateDocCsvFeederGuid     =   "{9CE40041-F057-4f9d-9A38-975AC970FF89}";
        public const string PrivateDocXmlFeederGuid     =   "{EDA52921-93E7-4b7f-B46B-5378DE15A064}";
        public const string PrivateDownLoadGuid         =   "{B9F6430B-904B-49c5-A106-CE317A91FD20}";
        public const string ShowPrivateDocumentGuid     =   "{D131BAE1-1AD2-4e2a-8E41-F65EC398DB3A}";

        #endregion const Guids for Emailing modules
        
        public const string Subject                 =   "TARGET_PAGE_SUBJECT";
        public const string EmailMandatory          =   "TARGET_PAGE_EMAILMANDATORY";
        public const string ProtectEmail            =   "TARGET_PAGE_PROTECTEMAIL";
        public const string OfferRegistering        =   "TARGET_PAGE_OFFERREGISTERING";
        public const string AddressMandatory        =   "TARGET_PAGE_ADDRESSANDATORY";
        public const string CrmMailTargetPageOwner  =   "TARGET_PAGE_OWNER";
        public const string AssignToOwner           =   "TARGET_PAGE_OWNER_ATTRIBUTE";
        public const string GenerateResponse        =   "TARGET_PAGE_GENERATERESPONSE";
        public const string Campaign                =   "TARGET_PAGE_CAMPAIGN";
        public const string DefaultCustomer         =   "TARGET_PAGE_DEFAULTCUSTOMER";
        public const string Task4Create             =   "TARGET_PAGE_TASK4NEWCREATED";
        public const string Queue4Task              =   "TARGET_PAGE_QUEUE4TASK";
        public const string ConvertTo               =   "TARGET_PAGE_CONVERTTO";
        public const string AllowUserInput          =   "TARGET_PAGE_ALLOWUSERINPUT";
        public const string AllowUserComment        =   "TARGET_PAGE_ALLOWUSERCOMMENT";
        public const string ShowWelcome             =   "TARGET_PAGE_SHOWWELCOME";
        public const string WelcomeMsg              =   "TARGET_PAGE_WELCOMEMSG";

        public const string DefaultFileExt          =   "PRIVATEDOC_DEFAULT_EXT";

        public const string FixedCampaign           =   "TEMPLATE_FIXEDCAMPAIGN";
        public const string BulkCampaign            =   "TEMPLATE_BULKSENDCAMPAIGN";
        public const string Assign2Owner            =   "TEMPLATE_ASSIGN2OWNER";
        public const string OpenHandlerType         =   "TEMPLATE_OPENHANDLERTYPE";
        public const string MaxErrors               =   "TEMPLATE_MAXERRORS";
        public const string PageSize                =   "TEMPLATE_PAGESIZE";
        public const string TargetDomain            =   "BULK_DEFAULT_TARGETDOMAIN";
        public const string ImgHandlerName          =   "BULK_IMAGEHANDLER";
        public const string SendMails               =   "BULK_SENDMAIL";
        public const string TimeoutDelay            =   "BULK_TIMEOUTDELAY";

        public const string InputOnly               =   "TEMPLATE_INPUTONLY";
        public const string TemplateOwner           =   "TEMPLATE_OWNER";
        public const string HtmlMode                =   "TEMPLATE_HTMLMODE";
        public const string PreviewMode             =   "TEMPLATE_PREVIEWMODE";
        public const string GoogleTranslate         =   "TEMPLATE_GOOGLETRANSLATE";

        public const string CRMEMailingSettings     =   "CRM_EMAILING_SETTINGS";

        public const string UseExternalSmtpServer   =   "SITESETTING_EMAILING_USEEXTSMTP";
        public const string SmtpServer              =   "SITESETTING_EMAILING_SMTPSERVER";
        public const string SmtpServerPort          =   "SITESETTING_EMAILING_SMTPSERVERPORT";
        public const string IFramePageMenu          =   "SITESETTINGS_IFRAMEPAGEMENU";  

        public const string RequireRegistered       =   "PRIVATEDOWNLOAD_REQUIREREGISTERED";
        public const string Transfer2Register       =   "PRIVATEDOWNLOAD_TRANSFER2REGISTER";


        // Crm entities
        public const string adnprivatedocument      =   "adn_privatedocument";
        public const string adnprivatedocumentid    =   "adn_privatedocumentid";
        public const string adntitle                =   "adn_title";
        public const string adnexternalid           =   "adn_externalid";
        public const string adnfilename             =   "adn_filename";
        public const string adndownloadcount        =   "adn_downloadcount";
        public const string adnfileurl              =   "adn_fileurl";
        public const string adncategory             =   "adn_category";
        public const string adnvaliduntil           =   "adn_validuntil";
        public const string adnlastsenton           =   "adn_lastsenton";
        public const string adnaccountid            =   "adn_accountid";
        public const string adncontactid            =   "adn_contactid";
        public const string adncampaignid           =   "adn_campaignid";
        public const string adnlistid               =   "adn_listid";
        public const string adnleadid               =   "adn_leadid";
        
        public const string adndownloadsession      =   "adn_downloadsession";
        public const string adndownloadsessionid    =   "adn_downloadsessionid";
        public const string adnprefix               =   "adn_prefix";
        public const string adnglobal               =   "adn_global";

        // IFrames, Builders
        public const string DownloadSessionDisplayName  =   "Download session";
        
        // DB access
        public const string ATPrivateDocumentId     =   "@PrivateDocumentId";
        public const string ATCrmPrivateDocumentId  =   "@CrmPrivateDocumentId";
        public const string ATTitle                 =   "@Title";
        public const string ATCategory              =   "@Category";
        public const string ATContenSize            =   "@ContentSize";
        public const string ATFilename              =   "@Filename";
        public const string ATFileUrl               =   "@FileUrl";
        public const string ATCreatedDate           =   "@CreatedDate";
        public const string ATUpdateDate            =   "@UpdateDate";
        public const string ATContent               =   "@Content";

        public const string DBPrivateDocumentId     =   "PrivateDocumentId";
        public const string DBCrmPrivateDocumentId  =   "CrmPrivateDocumentId";
        public const string DBTitle                 =   "Title";
        public const string DBCategory              =   "Category";
        public const string DBContenSize            =   "ContentSize";
        public const string DBFilename              =   "Filename";
        public const string DBFileUrl               =   "FileUrl";
        public const string DBCreatedDate           =   "CreatedDate";
        public const string DBUpdateDate            =   "UpdateDate";
        public const string DBContent               =   "Content";

    }
    
}
